﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetData();
        }

        string btnId = getPostBackControlName();

        if (!String.IsNullOrEmpty(btnId) && (btnId == "AddRowToParentBtn"))
        {
            int id = ((int)((DataSet)Session["GridData"]).Tables["Primary"].Rows[(((DataSet)Session["GridData"]).Tables["Primary"].Rows.Count - 1)].ItemArray[0]);
            id++;

            ((DataSet)Session["GridData"]).Tables["Primary"].Rows.Add(id, "New Hello " + id.ToString(), "Test" + (id % 3).ToString());

            ((DataTable)((DataSet)Session["GridData"]).Tables["Primary"]).AcceptChanges();
        }

        this.WebHierarchicalDataGrid1.DataSource = Session["GridData"];
        this.WebHierarchicalDataGrid1.DataBind();
    }

    public DataSet GetData()
    {
        DataSet ds = new DataSet();
        ds.Tables.Add(GetPrimary());
        ds.Tables.Add(GetChild());
        ds.Relations.Add(ds.Tables["Primary"].Columns["ID"], ds.Tables["Child"].Columns["ParentID"]);
        return ds;
    }

    public DataTable GetPrimary()
    {
        DataTable table = new DataTable("Primary");
        table.Columns.Add("ID", typeof(int));
        table.Columns.Add("Message", typeof(string));
        table.Columns.Add("Test", typeof(string));
        for (int i = 0; i <= 19; i++)
        {
            table.Rows.Add(i, "Hello " + i.ToString(), "Test" + (i % 3).ToString());
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["ID"] };
        return table;
    }

    public DataTable GetChild()
    {
        DataTable table = new DataTable("Child");
        table.Columns.Add("ChildID", typeof(int));
        table.Columns.Add("ParentID", typeof(int));
        table.Columns.Add("Message", typeof(string));
        for (int i = 0; i <= 50; i++)
        {
            table.Rows.Add(i, i % 3, "Hello " + (i % 3).ToString());
        }
        table.PrimaryKey = new DataColumn[] { table.Columns["ChildID"] };
        return table;
    }
    protected void Unnamed_RowsDeleting(object sender, Infragistics.Web.UI.GridControls.RowDeletingEventArgs e)
    {
        int rowId = Convert.ToInt32(e.Row.DataKey[0].ToString());
        DataSet ds = (DataSet)Session["GridData"];

        foreach (DataRow row in ds.Tables["Child"].Rows)
        {
            if ((int)row.ItemArray[0] == rowId)
            {
                row.Delete();
                break;
            }
        }
    }
    private string getPostBackControlName()
    {
        Control control = null;
        //first we will check the "__EVENTTARGET" because if post back made by       the controls
        //which used "_doPostBack" function also available in Request.Form collection.
        string ctrlname = Page.Request.Params["__EVENTTARGET"];
        if (ctrlname != null && ctrlname != String.Empty)
        {
            control = Page.FindControl(ctrlname);
        }
        // if __EVENTTARGET is null, the control is a button type and we need to
        // iterate over the form collection to find it
        else
        {
            string ctrlStr = String.Empty;
            Control c = null;
            foreach (string ctl in Page.Request.Form)
            {
                //handle ImageButton they having an additional "quasi-property" in their Id which identifies
                //mouse x and y coordinates
                if (ctl.EndsWith(".x") || ctl.EndsWith(".y"))
                {
                    ctrlStr = ctl.Substring(0, ctl.Length - 2);
                    c = Page.FindControl(ctrlStr);
                }
                else
                {
                    c = Page.FindControl(ctl);
                }
                if (c is System.Web.UI.WebControls.Button ||
                         c is System.Web.UI.WebControls.ImageButton)
                {
                    control = c;
                    break;
                }
            }
        }
        return (control == null) ? "" : control.ID;

    }
}